/* 
 * File:   videocapture.cpp
 * Author: gb
 *
 * Created on 2 de Novembro de 2015, 18:50
 */

#include "opencv2/opencv.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/highgui/highgui.hpp"

using namespace cv;

#define media 0
#define gaussiano 0
#define bilateral 0
#define mediana 1

int size = 3;

void salt(Mat &image, int n);

int main(int, char**)
{
    Mat original = imread("lenna.png");
    Mat resultado;
    //filtro da média
    if (media)
        blur( original, resultado, Size( size, size ));

    if (gaussiano)
        GaussianBlur( original, resultado, Size( size, size ),1,1);
    
    if (bilateral)
        bilateralFilter(original, resultado, size, size*2, size/2);
    
    if (mediana){
        salt(original, 3000);
        medianBlur(original, resultado, size);
    }
    
    //imwrite( "saida.png", resultado);
    imshow("Filtros", resultado);  
    cvWaitKey(0);
    
    return 0;
}


void salt(Mat &image, int n) {
      for (int k=0; k<n; k++) {

        int i= rand()%image.cols;
        int j= rand()%image.rows;
         
        image.at<cv::Vec3b>(j,i)[0]= 255;
        image.at<cv::Vec3b>(j,i)[1]= 255;
        image.at<cv::Vec3b>(j,i)[2]= 255;
    }
}